"use strict";

exports.__esModule = true;
exports["default"] = Popper;
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// eslint-disable-line no-unused-vars
function Popper(getDeps, props) {
  var _getDeps = getDeps(),
    createPopper = _getDeps.createPopper,
    getPopperMaxHeight = _getDeps.getPopperMaxHeight,
    getPopperMaxWidth = _getDeps.getPopperMaxWidth;
  var rootRef = props.rootRef,
    children = props.children,
    style = props.style,
    fullWidth = props.fullWidth,
    placement = props.placement;
  var popperRef = (0, _react.useRef)();
  var ref = (0, _react.useRef)();
  ref.current = ref.current || {};
  (0, _react.useLayoutEffect)(function () {
    popperRef.current.style.maxHeight = getPopperMaxHeight(rootRef.current, 8) + 'px';
    var popperIns = createPopper(rootRef.current, popperRef.current, fullWidth, placement);
    ref.current.popperIns = popperIns;
    return function () {
      popperIns.destroy();
    };
  }, []);
  (0, _react.useLayoutEffect)(function () {
    ref.current && ref.current.popperIns && ref.current.popperIns.update().then(function () {
      popperRef.current.style.maxWidth = getPopperMaxWidth(popperRef.current, 8) + 'px';
    });
  }, [children]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    ref: popperRef,
    className: "rc-search-suggestions-popper",
    style: style,
    tabIndex: 0
  }, children));
}