function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React, { useRef, useState, useCallback, useEffect } from 'react'; // eslint-disable-line no-unused-vars
import Popper from './popper'; // eslint-disable-line no-unused-vars
import MagnifierIcon from './icons/magnifier.js';
import ClearIcon from './icons/clear.js';
/**
 *
 * @param {Object} props
 * @param {React.ReactNode} [props.children=null] - will be shown in popup
 * @param {value} props.value - input value
 * @param {Function} props.onChange - onChange function for input
 * @param {Object} [props.rootStyle={}] - style object of the root element
 * @param {Object} [props.inputContainerStyle={}] - style object of the parent element of text input
 * @param {Object} [props.inputStyle={}] - style object of the input element
 * @param {String} [props.placeholder="search"]
 * @param {Function} [props.onKeyDown=()=>{}] - keydown event for input
 * @param {Function} [props.onFocus=()=>{}] - focus event for input
 * @param {Function} [props.onBlur=()=>{}] - blur event for the input
 * @param {Object} [props.popperStyle={}] - style object for popper container
 * @param {Boolean} [props.fullWidth=true] - set popper width same as input
 * @param {'auto'| 'auto-start'| 'auto-end'| 'top'| 'top-start'| 'top-end'| 'bottom'| 'bottom-start'| 'bottom-end'| 'right'| 'right-start'| 'right-end'| 'left'| 'left-start'| 'left-end'} [props.placement="bottom-start"] - popper's placement
 * @param {React.FC} [props.ClearIconComponent=ClearIcon] - custom Clear icon
 * @param {React.FC} [props.MagnifierIconComponent=MagnifierIcon] - custom Magnifier icon
 * @param {Function} [props.onClear=()=>{}] - triggerd when the user clicks on the default Clear icon
 * @param {"underline"|"outline"|"panel"} [props.theme="outline"] - searchbox theme
 * @param {Boolean} [props.corner=true] - if set true then border-radius would be "5px"
 * @param {Boolean} [props.autoFocus=false] - autoFocus attribute for the input element
 * @param {String} [props.inputName=""] - name attribute for the input element
 * @param {Boolean} [props.openOnClick=true] - if it is true then the suggestion list will be open when the user clicks on the input
 * @param {(e)=>Boolean} [props.openOnKeyDown=(e)=>e.key === 'Enter'] -it it returns true then the suggestion list will be open
 */
function ReactCustomSearchList(props) {
  var _props$children = props.children,
    children = _props$children === void 0 ? null : _props$children,
    _props$value = props.value,
    value = _props$value === void 0 ? '' : _props$value,
    onChange = props.onChange,
    _props$rootStyle = props.rootStyle,
    rootStyle = _props$rootStyle === void 0 ? {} : _props$rootStyle,
    _props$inputContainer = props.inputContainerStyle,
    inputContainerStyle = _props$inputContainer === void 0 ? {} : _props$inputContainer,
    _props$inputStyle = props.inputStyle,
    inputStyle = _props$inputStyle === void 0 ? {} : _props$inputStyle,
    _props$placeholder = props.placeholder,
    placeholder = _props$placeholder === void 0 ? 'search' : _props$placeholder,
    _props$onKeyDown = props.onKeyDown,
    onKeyDown = _props$onKeyDown === void 0 ? function () {} : _props$onKeyDown,
    _props$onFocus = props.onFocus,
    onFocus = _props$onFocus === void 0 ? function () {} : _props$onFocus,
    _props$onBlur = props.onBlur,
    onBlur = _props$onBlur === void 0 ? function () {} : _props$onBlur,
    _props$popperStyle = props.popperStyle,
    popperStyle = _props$popperStyle === void 0 ? {} : _props$popperStyle,
    _props$fullWidth = props.fullWidth,
    fullWidth = _props$fullWidth === void 0 ? true : _props$fullWidth,
    _props$placement = props.placement,
    placement = _props$placement === void 0 ? 'bottom-start' : _props$placement,
    _props$ClearIconCompo = props.ClearIconComponent,
    ClearIconComponent = _props$ClearIconCompo === void 0 ? ClearIcon : _props$ClearIconCompo,
    _props$MagnifierIconC = props.MagnifierIconComponent,
    MagnifierIconComponent = _props$MagnifierIconC === void 0 ? MagnifierIcon : _props$MagnifierIconC,
    _props$onClear = props.onClear,
    onClear = _props$onClear === void 0 ? function () {} : _props$onClear,
    _props$theme = props.theme,
    theme = _props$theme === void 0 ? 'outline' : _props$theme,
    _props$corner = props.corner,
    corner = _props$corner === void 0 ? true : _props$corner,
    _props$autoFocus = props.autoFocus,
    autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
    _props$inputName = props.inputName,
    inputName = _props$inputName === void 0 ? '' : _props$inputName,
    _props$openOnClick = props.openOnClick,
    openOnClick = _props$openOnClick === void 0 ? true : _props$openOnClick,
    _props$openOnKeyDown = props.openOnKeyDown,
    openOnKeyDown = _props$openOnKeyDown === void 0 ? function (e) {
      return e.key === 'Enter' || e.keyCode === 13;
    } : _props$openOnKeyDown;
  var _useState = useState(false),
    open = _useState[0],
    setOpen = _useState[1];
  var rootRef = useRef();
  var onClickHandler = useCallback(function () {
    openOnClick && setOpen(true);
  }, [openOnClick]);
  var onKeyDownHandler = useCallback(function (e) {
    if (openOnKeyDown(e) == true) {
      setOpen(true);
    }
    onKeyDown(e);
  }, [onKeyDown, openOnKeyDown]);
  useEffect(function () {
    var rEl = document.documentElement,
      input = rootRef.current.querySelector('input');
    var mousedown = function mousedown(e) {
      return open && e.target == input && e.stopImmediatePropagation();
    };
    rEl.addEventListener('click', mousedown, {
      useCapture: true
    });
    return function () {
      rEl.removeEventListener('click', mousedown, {
        useCapture: true
      });
    };
  }, [open]);
  useEffect(function () {
    var click = function click() {
      setTimeout(function () {
        setOpen(false);
      });
    };
    open ? document.documentElement.addEventListener('click', click, {
      once: true,
      useCapture: true
    }) : document.documentElement.removeEventListener('click', click, {
      once: true,
      useCapture: true
    });
    return function () {
      if (open) {
        document.documentElement.removeEventListener('click', click, {
          once: true,
          useCapture: true
        });
      }
    };
  }, [open]);
  return /*#__PURE__*/React.createElement("div", {
    className: "rc-search-suggestions-root " + theme + (corner ? ' corner' : ''),
    style: rootStyle
  }, open && children != null && children.length !== 0 ? /*#__PURE__*/React.createElement(Popper, {
    rootRef: rootRef,
    style: popperStyle,
    fullWidth: theme === 'panel' ? true : fullWidth,
    placement: placement
  }, children) : null, /*#__PURE__*/React.createElement("div", {
    className: "rc-search-suggestions-container",
    ref: rootRef,
    style: inputContainerStyle
  }, MagnifierIconComponent ? /*#__PURE__*/React.createElement(MagnifierIconComponent, null) : null, /*#__PURE__*/React.createElement("input", _extends({
    value: value,
    onChange: onChange,
    onFocus: onFocus,
    onClick: onClickHandler,
    onKeyDown: onKeyDownHandler,
    onBlur: onBlur,
    placeholder: placeholder,
    style: inputStyle,
    autoFocus: autoFocus
  }, inputName ? {
    name: inputName
  } : {})), ClearIconComponent ? /*#__PURE__*/React.createElement(ClearIconComponent, {
    value: value,
    onClear: onClear
  }) : null, /*#__PURE__*/React.createElement("div", {
    className: "rc-search-suggestions-divider rc-search-suggestions-divider-bottom"
  }), /*#__PURE__*/React.createElement("div", {
    className: "rc-search-suggestions-divider rc-search-suggestions-divider-top"
  })));
}
export default ReactCustomSearchList;