import React, { useLayoutEffect, useRef } from 'react'; // eslint-disable-line no-unused-vars
export default function Popper(getDeps, props) {
  var _getDeps = getDeps(),
    createPopper = _getDeps.createPopper,
    getPopperMaxHeight = _getDeps.getPopperMaxHeight,
    getPopperMaxWidth = _getDeps.getPopperMaxWidth;
  var rootRef = props.rootRef,
    children = props.children,
    style = props.style,
    fullWidth = props.fullWidth,
    placement = props.placement;
  var popperRef = useRef();
  var ref = useRef();
  ref.current = ref.current || {};
  useLayoutEffect(function () {
    popperRef.current.style.maxHeight = getPopperMaxHeight(rootRef.current, 8) + 'px';
    var popperIns = createPopper(rootRef.current, popperRef.current, fullWidth, placement);
    ref.current.popperIns = popperIns;
    return function () {
      popperIns.destroy();
    };
  }, []);
  useLayoutEffect(function () {
    ref.current && ref.current.popperIns && ref.current.popperIns.update().then(function () {
      popperRef.current.style.maxWidth = getPopperMaxWidth(popperRef.current, 8) + 'px';
    });
  }, [children]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    ref: popperRef,
    className: "rc-search-suggestions-popper",
    style: style,
    tabIndex: 0
  }, children));
}