/**
 * react-custom-search-list - A customizable React search input component with dynamic popup suggestions, allowing developers to create unique search experiences.
 *
 * @version v2.2.1
 * @homepage https://github.com/dev-javascript/react-custom-search-list#readme
 * @author dev-javascript javascript.code.dev@gmail.com
 * @license MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("react"),require("@popperjs/core/lib/popper-lite"),require("@popperjs/core/lib/modifiers/flip"),require("@popperjs/core/lib/modifiers/preventOverflow"),require("@popperjs/core/lib/modifiers/computeStyles")):"function"==typeof define&&define.amd?define(["react","@popperjs/core/lib/popper-lite","@popperjs/core/lib/modifiers/flip","@popperjs/core/lib/modifiers/preventOverflow","@popperjs/core/lib/modifiers/computeStyles"],t):(e="undefined"!=typeof globalThis?globalThis:e||self).ReactCustomSearchList=t(e.React,e.Popper,e.Popper.flip,e.Popper.preventOverflow,e.Popper.computeStyles)}(this,(function(e,t,n,r,o){"use strict";function i(e,i,c,u){var l={placement:u,strategy:"fixed",modifiers:[n,r]};return 1==c&&(l.placement="bottom-start",l.modifiers.push({name:"sameWidth",enabled:!0,fn:function(e){var t=e.state;t.styles.popper.width=t.rects.reference.width+"px"},phase:"beforeWrite",requires:[o]})),t.createPopper(e,i,l)}function c(e,t){var n=e.getBoundingClientRect(),r=n.top,o=n.bottom;return o=Math.max(document.documentElement.clientHeight||0,window.innerHeight||0)-o,Math.max(r,o)-t}function u(e,t){var n=e.getBoundingClientRect().left;return Math.max(document.documentElement.clientWidth||0,window.innerWidth||0)-n-t}r.options={padding:0,boundariesElement:"viewport"};var l=function(t,n){var r=t(),o=r.createPopper,i=r.getPopperMaxHeight,c=r.getPopperMaxWidth,u=n.rootRef,l=n.children,a=n.style,s=n.fullWidth,p=n.placement,d=e.useRef(),f=e.useRef();return f.current=f.current||{},e.useLayoutEffect((function(){d.current.style.maxHeight=i(u.current,8)+"px";var e=o(u.current,d.current,s,p);return f.current.popperIns=e,function(){e.destroy()}}),[]),e.useLayoutEffect((function(){f.current&&f.current.popperIns&&f.current.popperIns.update().then((function(){d.current.style.maxWidth=c(d.current,8)+"px"}))}),[l]),e.createElement(e.Fragment,null,e.createElement("div",{ref:d,className:"rc-search-suggestions-popper",style:a,tabIndex:0},l))}.bind(null,(function(){return{createPopper:i,getPopperMaxHeight:c,getPopperMaxWidth:u}}));function a(t){return e.createElement("svg",{className:"sc-bcXHqe hVRzLL search-icon",width:"20",height:"20",focusable:"false",xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",style:{backgroundColor:"white"}},e.createElement("path",{d:"M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"}))}function s(t){var n=t.value,r=t.onClear;return e.createElement("svg",{width:"20",height:"20",focusable:"false",xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",onClick:function(e){r(e)},style:{backgroundColor:"white",cursor:"pointer",opacity:n.length?1:0}},e.createElement("path",{d:"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.58 12 5 17.58 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"}))}function p(){return p=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)({}).hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},p.apply(null,arguments)}return function(t){var n=t.children,r=void 0===n?null:n,o=t.value,i=void 0===o?"":o,c=t.onChange,u=t.rootStyle,d=void 0===u?{}:u,f=t.inputContainerStyle,m=void 0===f?{}:f,v=t.inputStyle,h=void 0===v?{}:v,g=t.placeholder,y=void 0===g?"search":g,E=t.onKeyDown,b=void 0===E?function(){}:E,w=t.onFocus,C=void 0===w?function(){}:w,x=t.onBlur,k=void 0===x?function(){}:x,P=t.popperStyle,L=void 0===P?{}:P,S=t.fullWidth,j=void 0===S||S,M=t.placement,R=void 0===M?"bottom-start":M,W=t.ClearIconComponent,q=void 0===W?s:W,O=t.MagnifierIconComponent,I=void 0===O?a:O,N=t.onClear,B=void 0===N?function(){}:N,H=t.theme,F=void 0===H?"outline":H,z=t.corner,D=void 0===z||z,K=t.autoFocus,T=void 0!==K&&K,V=t.inputName,X=void 0===V?"":V,A=t.openOnClick,G=void 0===A||A,J=t.openOnKeyDown,Q=void 0===J?function(e){return"Enter"===e.key||13===e.keyCode}:J,U=e.useState(!1),Y=U[0],Z=U[1],$=e.useRef(),_=e.useCallback((function(){G&&Z(!0)}),[G]),ee=e.useCallback((function(e){1==Q(e)&&Z(!0),b(e)}),[b,Q]);return e.useEffect((function(){var e=document.documentElement,t=$.current.querySelector("input"),n=function(e){return Y&&e.target==t&&e.stopImmediatePropagation()};return e.addEventListener("click",n,{useCapture:!0}),function(){e.removeEventListener("click",n,{useCapture:!0})}}),[Y]),e.useEffect((function(){var e=function(){setTimeout((function(){Z(!1)}))};return Y?document.documentElement.addEventListener("click",e,{once:!0,useCapture:!0}):document.documentElement.removeEventListener("click",e,{once:!0,useCapture:!0}),function(){Y&&document.documentElement.removeEventListener("click",e,{once:!0,useCapture:!0})}}),[Y]),e.createElement("div",{className:"rc-search-suggestions-root "+F+(D?" corner":""),style:d},Y&&null!=r&&0!==r.length?e.createElement(l,{rootRef:$,style:L,fullWidth:"panel"===F||j,placement:R},r):null,e.createElement("div",{className:"rc-search-suggestions-container",ref:$,style:m},I?e.createElement(I,null):null,e.createElement("input",p({value:i,onChange:c,onFocus:C,onClick:_,onKeyDown:ee,onBlur:k,placeholder:y,style:h,autoFocus:T},X?{name:X}:{})),q?e.createElement(q,{value:i,onClear:B}):null,e.createElement("div",{className:"rc-search-suggestions-divider rc-search-suggestions-divider-bottom"}),e.createElement("div",{className:"rc-search-suggestions-divider rc-search-suggestions-divider-top"})))}}));
//# sourceMappingURL=react-custom-search-list.umd.min.js.map
